package com.ruoyi.web.base.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.ProductionRegularGrading;
import com.ruoyi.web.base.service.IProductionRegularGradingService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

@RestController
@RequestMapping("/production-regular-grading")
public class ProductionRegularGradingController {

    @Autowired
    private IProductionRegularGradingService productionRegularGradingService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("生产常规分级添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody ProductionRegularGrading grading, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (productionRegularGradingService.count(
                new QueryWrapper<ProductionRegularGrading>()
                        .eq("org_id", loginOrgId)
                        .eq("production_plan_number", grading.getProductionPlanNumber())
        ) > 0) {
            throw new Exception("该分级编号已存在");
        }
        grading.setOrgId(loginOrgId);
        grading.setCreateBy(getUsername());
        return success(productionRegularGradingService.save(grading));
    }

    @ApiOperation("生产常规分级修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody ProductionRegularGrading grading, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (productionRegularGradingService.count(
                new QueryWrapper<ProductionRegularGrading>()
                        .ne("id", grading.getId())
                        .eq("org_id", loginOrgId)
                        .eq("production_plan_number", grading.getProductionPlanNumber())
        ) > 0) {
            throw new Exception("该分级编号已存在");
        }
        grading.setUpdateBy(getUsername());
        return success(productionRegularGradingService.updateById(grading));
    }

    @ApiOperation("生产常规分级删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String id : ids.split(",")) {
            productionRegularGradingService.removeById(id);
        }
        return success();
    }

    @ApiOperation("生产常规分级列表")
    @PostMapping("/list")
    public AjaxResult listAll(HttpServletRequest request) {
        return success(productionRegularGradingService.list(
                new QueryWrapper<ProductionRegularGrading>()
                        .eq("org_id", tokenService.getLoginOrgId(request))
        ));
    }

    @ApiOperation("生产常规分级分页")
    @GetMapping("/page")
    public AjaxResult page(
            @RequestParam("pageNum") Integer pageNum,
            @RequestParam("pageSize") Integer pageSize,
            HttpServletRequest request
    ) {
        return success(productionRegularGradingService.page(
                new Page<ProductionRegularGrading>(pageNum, pageSize),
                new QueryWrapper<ProductionRegularGrading>()
                        .eq("org_id", tokenService.getLoginOrgId(request))
        ));
    }

    @ApiOperation("生产常规分级详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        return success(productionRegularGradingService.getById(id));
    }
}